/*!
 * @file ogg_player.h
 * @brief Ogg-Player definition
 */


#ifndef _OGG_PLAYER_H
#define _OGG_PLAYER_H

#include <string>
#include <iostream>
using namespace std;

#include <AL/al.h>
#include <ogg/ogg.h>
#include <vorbis/vorbisfile.h>



#define BUFFER_SIZE (4096 * 4)



class OggStream
{
    public:

        void open(string path);
        void release();
        void display();
        bool playback();
        bool playing();
        bool update();

    protected:

        bool stream(ALuint buffer);
        void empty();
        void check();
        const char* errorString(int code);

    private:

        FILE*             oggFile;
        OggVorbis_File    oggStream;
        vorbis_info*      vorbisInfo;
        vorbis_comment*   vorbisComment;

        ALuint            buffers[2];
        ALuint            source;
        ALenum            format;
};


#endif /* _OGG_PLAYER_H */
